import idorudraw as D
import arc
import cadget

def load_font(name):
    ## Add exception handling
    fp = open((cadget.data_path() + "/cxf/" + name + ".cxf"))
    ## Load the header - better ignore it.
    line = fp.readline()
    while len(line) > 2: ## Another dirty hack
        print line
        line = fp.readline()
    
    ## Begin to load the characters into a dictionary
    font = {}
    character = ''
    lines = []
    arcs = []
    
    while line.find("#EOF") < 0:
        line = fp.readline()
        if line[0] == '[':
            character = line[1]
        elif line[0] == 'A':
            if line[1] == 'R':
                tmp = (line.split())[1].split(',')
                arcs.append([tmp[0], tmp[1], tmp[2], tmp[4], tmp[3]])
            else:
                arcs.append((line.split())[1].split(','))
        elif line[0] == 'L':
            lines.append((line.split())[1].split(','))
        elif line[0] == '\n': ## check it - may not be portable (\r\n, etc)
            font[character] = [lines, arcs]
            arcs = []
            lines = []
    fp.close()
    return font


## FIXME: the kerning is FUBAR and just hacked together
def write_char(char, font, x=0, y=0, scale = 10):

    if char.isspace():
        return 0

    rescale = scale/10.0
    
    right_limit = 0
    l, a = font[char]

    if len(l) > 0:
        D.beginLinesEntity()
        for i in range(len(l)):
            D.line(rescale*float(l[i][0])+x, rescale*float(l[i][1])+y,
                   rescale*float(l[i][2])+x, rescale*float(l[i][3])+y)

    if len(a) > 0:
        for i in range(len(a)):
            arc.craa(rescale*float(a[i][0])+x, rescale*float(a[i][1])+y,
                     rescale*float(a[i][2]), float(a[i][3]),
                     float(a[i][4]))
                
    return right_limit

## FIXME: code duplication, "centered" missing
def write(str, font, x=0, y=0, scale = 10, align = 0):
    ptr = x
    if align == 2:
        tmp = []
        ## Just copy the string to a list to reverse it easily
        for i in range(len(str.strip())):
            tmp.append(str.strip()[i])
        tmp.reverse()
        for i in tmp:
            ptr -= 7.0*scale/10.0
            write_char(i, font, ptr, y, scale)
    elif align == 1:
        avg = int(len(str)/2)-1 ## -1: fixing the rounding
        left = str[:avg]
        right = str[avg:]
        write(left, font, x, y, scale, 2)
        write(right, font, x, y, scale, 0)
    elif align == 0:
        for i in str:
            #ptr += write_char(i, font, ptr, y, scale)
            write_char(i, font, ptr, y, scale)
            ptr += 7.0*scale/10.0
