## Functions commented out and labeled COMPLEX require usage
## of the Numeric module instead of math; file dependence and
## move out of the way

import math; M=math

# hypot(x, y) for three axis
def hypot3(x, y, z):
    return M.sqrt(x*x + y*y + z*z)

#
def func(x, y, z=0):
    return (M.cos(float(x)/4) + M.sin(float(y)/5))*4

#
def cltz(x, y, z=0):
    count = 0
    converge = 0
    diverge = 0
    r = complex(x+20.0, y+20.0)
    while r.real > 1:
        if not r.real%2:
            r /= 2.0
            converge += 1
        else:
            r = (3*r + 1) / 2.0
            diverge += 1
        count += 1
    return count
#    if(converge):
#        return float(diverge)/float(converge)
#    else:
#        return 0

#
def spheric(x, y, z=0):
    return M.sqrt(abs(250 - (x**2 + y**2)))

#
def linear(x, y, z=0):
    return x+y

#
def cuadric(x, y, z=0):
    return x**2+y**2

#
def imgquad(x, y, z=0):
    i = complex(x, y)
    d = i**2
    return d.real

def cnone(x, y):
    i = complex(x, y)
    return i

## ## COMPLEX
## def cquad(x, y):
##     i = complex(x, y)
##     d = i**2
##     return d

## ## COMPLEX
## def clog(x, y):
##     i = complex(x, y)
##     n = complex(e, e)
##     d = n**i
##     if abs(d) < 500:
##         return d
##     else:
##         return (d * 500)/abs(d)

#
def iexp(x, y):
    i = complex(x, y)
    n = complex(e, e)
    d = n**i
    if d.imag < 500:
        return d.imag
    else:
        return 500

## ## COMPLEX
## def cfib(x, y):
##     i = complex(x, y)
##     d = i**2 + i
##     return d

#
def elliptic(x, y, z=0):
    return ((x+y)**3 + (x+y)**2 + (x+y))/64000.0

#
def k_ish(x, y, z=0):
    return (x**2 + 2 - y**3)

#
def expic(x, y, z=0):
    if x:
        return M.log(M.fabs(x)**y)
    else:
        return -52

#
def mandel(x, y, z=0):
    s = 19.0
    iter = 170
    i = complex(x/s, y/s)
    count = 0
    n = complex(0, 0)
    while abs(n) < 2.0 and count < iter:
        n = n**2 + i
        count = count + 1
    if count == iter:
        count = 0
    return count

## ## COMPLEX
## def imexp(x, y, z = 0, res = 1):
##     i = complex(x/4., y/4.)
##     x = exp(i)
##     r = [x.real, x.imag, abs(x)]
##     return r[res]

## ## COMPLEX
## def invexp(x, y, z = 0, res = 0):
##     i = complex(x/40., y/40.)
##     x = exp(1./i)
##     r = [x.real, x.imag, abs(x)]
##     return r[res]

## ## COMPLEX
## def imcos(x, y, z=0, res=0):
##     i = complex(x/3.3, y/3.3)
##     x = cos(i)
##     r = [x.real, x.imag, abs(x)]
##     return r[res]

## ## COMPLEX
## def imtan(x, y, z=0, res=2):
##     i = complex(x/5, y/5)
##     x = tan(i)
##     r = [x.real, x.imag, abs(x)]
##     return r[res]

## ## COMPLEX
## def imsec(x, y, z=0, res=1):
##     i = complex(x/10., y/10.)
##     x = 1./cos(i)
##     r = [x.real, x.imag, abs(x)]
##     return r[res]

## ## COMPLEX
## def imlog(x, y, z=0, res=2):
##     i = complex(x/10., y/10.)
##     x = log(i)
##     r = [x.real, x.imag, abs(x)]
##     return r[res]

#
def cubics(x, y, z=0):
    return -M.sqrt(M.sqrt(abs(float(x)**4 + float(y)**3)))

#
def flat(x, y, z=0):
    return 10

#
def none(x=0, y=0, z=0):
    return 0

#
def ripple(x, y, z=0):
    return M.sin(M.sqrt(x**2 + y**2)) * 0.3 #+ sin(x/4.) + cos(y/4.)
#   return sin(sqrt(x**2 + y**2)) * 0.3 + sqrt(abs(x**2 - y**3))/10.0


def wavy(x, y, z=0):
    return M.sin(M.atan2(y, x)*12)

def flower_sombrero(x, y, z=0):
    if M.hypot(x, y):
        return M.sin(M.hypot(x, y)*180/M.pi)/M.hypot(x, y)
    else:
        return 0

def sombrero(x, y, z=0):
    if M.hypot(x, y):
        return M.sin(M.hypot(x, y))*5/M.hypot(x, y)
    else:
        return 5

# Solutions for x + 1 = -(1/x)

def fc1(x, y, z=0):
    j = complex(x, y)
    i = j**2.0 + j
    r = [abs(i), i.real, i.imag]
    return r[1]

def fc2(x, y, z=0):
    j = complex(x, y)
    i = (j**2) + j
    r = [abs(i), i.real, i.imag]
    return r[2]
    

