from idorudraw import triangle_from, triangle_to
from idorudraw import beginTrianglesEntity, triangle

def avg(x, y):
    return (x+y)/2.0

def tetra(x0, y0, x1, y1, x2, y2, x3, y3,
          z0=0, z1=0, z2=0, z3=0):
    #    beginTrianglesEntity()
    triangle(x0, y0, x2, y2, x1, y1,
             z0, z2, z1)
    triangle(x0, y0, x1, y1, x3, y3,
             z0, z1, z3)
    triangle(x1, y1, x2, y2, x3, y3,
             z1, z2, z3)
    triangle(x0, y0, x3, y3, x2, y2,
             z0, z3, z2)

def cell(x0, y0, x1, y1, x2, y2, x3, y3,
         z0=0, z1=0, z2=0, z3=0):
    x01 = avg(x0, x1); y01 = avg(y0, y1); z01 = avg(z0, z1)
    x02 = avg(x0, x2); y02 = avg(y0, y2); z02 = avg(z0, z2)
    x03 = avg(x0, x3); y03 = avg(y0, y3); z03 = avg(z0, z3)
    x12 = avg(x1, x2); y12 = avg(y1, y2); z12 = avg(z1, z2)
    x23 = avg(x2, x3); y23 = avg(y2, y3); z23 = avg(z2, z3)
    x13 = avg(x1, x3); y13 = avg(y1, y3); z13 = avg(z1, z3)
    return [x0, y0, x01, y01, x02, y02, x03, y03, z0, z01, z02, z03,
            x01, y01, x1, y1, x12, y12, x13, y13, z01, z1, z12, z13,
            x02, y02, x12, y12, x2, y2, x23, y23, z02, z12, z2, z23,
            x03, y03, x13, y13, x23, y23, x3, y3, z03, z13, z23, z3
            ]

def pyramid(x0, y0, x1, y1, x2, y2, x3, y3,
            z0=0, z1=0, z2=0, z3=0, n=4):
    beginTrianglesEntity()
    s = cell(x0, y0, x1, y1, x2, y2, x3, y3,
             z0, z1, z2, z3)
    for i in range(1, n):
        r = s
        s = []
        for j in range(4.0**i):
            s.extend( cell(r[j*12 + 0], r[j*12 + 1],
                           r[j*12 + 2], r[j*12 + 3],
                           r[j*12 + 4], r[j*12 + 5],
                           r[j*12 + 6], r[j*12 + 7],
                           r[j*12 + 8], r[j*12 + 9],
                           r[j*12 + 10], r[j*12 + 11] ))
    for i in range(4.0**n):
        tetra(s[i*12 + 0], s[i*12 + 1], s[i*12 + 2], s[i*12 + 3],
              s[i*12 + 4], s[i*12 + 5], s[i*12 + 6], s[i*12 + 7],
              s[i*12 + 8], s[i*12 + 9], s[i*12 + 10], s[i*12 + 11])
