### NOTE: all the instances where 'fnc' was different to
### 'none' were replaced. TODO: find out the problem
### with the scope.

from f_de_xyz import hypot3, none
from idorudraw import beginTrianglesEntity, triangle
from idorudraw import triangle_from, triangle_to, triangle
from glstate import update

import math; M=math

# single triangles volume; deprecated in favor of triangle strips

def volume(x = 20, y = 20, fnc = none, l = 1, s = 0, t = 0):
    beginTrianglesEntity(l)
    for i in range(-x, x+1):
        if s:
            beginTrianglesEntity((i%4)+l)
        for j in range(-y, y+1):
            if t:
                beginTrianglesEntity(randrange(1, 5))
            triangle( i, j-1, i+1, j-1, i, j,
                      fnc(i, j-1), fnc(i+1, j-1), fnc(i, j))
            if t:
                beginTrianglesEntity(randrange(1, 5))
            triangle( i, j, i+1, j-1, i+1, j,
                      fnc(i, j), fnc(i+1, j-1), fnc(i+1, j))

# El centro no est bien iluminado
def disk(x = 0, y = 0, a=0.001, n=100, l=1, fnc=none):
    d =0.0
    triangle_from(x, y, x, y, fnc(x, y), fnc(x, y), l)
    triangle_to(x+(M.cos(d*M.pi/180))*a*d,
                y+(M.sin(d*M.pi/180))*a*d,
                fnc(x+(M.cos(d*M.pi/180))*a*d, y+(M.sin(d*M.pi/180))*a*d))
    for i in range(1, 73):
        d = d + 5.0
        triangle_to(x+(M.cos(d*M.pi/180))*a*d,
                    y+(M.sin(d*M.pi/180))*a*d,
                    fnc(x+(M.cos(d*M.pi/180))*a*d, y+(M.sin(d*M.pi/180))*a*d))
        triangle_to(x, y, fnc(x, y))
    for i in range(1, n):
        for j in range(1, 73):
            d = d + 5.0
            triangle_to(x+(M.cos(d*M.pi/180))*a*d,
                        y+(M.sin(d*M.pi/180))*a*d,
                        fnc(x+(M.cos(d*M.pi/180))*a*d,
                            y+(M.sin(d*M.pi/180))*a*d))
            triangle_to(x+(M.cos(d*M.pi/180))*a*(d-360),
                        y+(M.sin(d*M.pi/180))*a*(d-360),
                        fnc(x+(M.cos(d*M.pi/180))*a*(d-360),
                            y+(M.sin(d*M.pi/180))*a*(d-360)))

def diskdp(x = 0, y = 0, a=0.0001, n=1000, l=1, fnc=none):
    d =0.0
    triangle_from(x, y, x, y, fnc(x, y), fnc(x, y), l)
    triangle_to(x+(M.cos(d*M.pi/180))*a*d,
                y+(M.sin(d*M.pi/180))*a*d,
                fnc(x+(M.cos(d*pi/180))*a*d, y+(M.sin(d*pi/180))*a*d))
    for i in range(1, 361):
        d = d + 1.0
        triangle_to(x+(M.cos(d*M.pi/180))*a*d,
                    y+(M.sin(d*M.pi/180))*a*d,
                    fnc(x+(M.cos(d*M.pi/180))*a*d,
                        y+(M.sin(d*M.pi/180))*a*d))
        triangle_to(x, y, fnc(x, y))
    for i in range(1, n):
        for j in range(1, 361):
            d = d + 1.0
            triangle_to(x+(M.cos(d*M.pi/180))*a*d,
                        y+(M.sin(d*M.pi/180))*a*d,
                        fnc(x+(M.cos(d*M.pi/180))*a*d,
                            y+(M.sin(d*M.pi/180))*a*d))
            triangle_to(x+(M.cos(d*M.pi/180))*a*(d-360),
                        y+(M.sin(d*M.pi/180))*a*(d-360),
                        fnc(x+(M.cos(d*M.pi/180))*a*(d-360),
                            y+(M.sin(d*M.pi/180))*a*(d-360)))


# A single line of a volume
def str(x1, x2, y=0, fnc=none, width=1, l = 1):
    triangle_from(x1, y+width,
                  x1, y-width,
                  fnc(x1, y+width), fnc(x1, y-width), l)
    for i in range(x1+1, (x2+1)):
        triangle_to(float(i)-0.5, y + width, fnc(float(i)-0.5, y + width))
        triangle_to(float(i)-0.5, y - width, fnc(float(i)-0.5, y - width))
        triangle_to(float(i), y + width, fnc(float(i), y + width))
        triangle_to(float(i), y - width, fnc(float(i), y - width))
    update()

## COMPLEX
# The same, for a function returning a complex tuple
# The way this will be done: z is the real component,
# and is shifted on y by the imaginary component.
# Alternatively, the imaginary shifting can be done along a radius.
## def cstr(x1, x2, y=0, fnc=none, width=1, l = 1):
##     triangle_from(x1, (y+width) + fnc(x1, y+width).imag,
##                   x1, (y-width) + fnc(x1, y-width).imag,
##                   fnc(x1, y+width).real, fnc(x1, y-width).real, l)
##     for i in range(x1+1, (x2+1)):
##         triangle_to(float(i)-0.5,
##                     (y + width) + fnc(x1, y+width).imag,
##                     fnc(float(i)-0.5, y + width).real)
##         triangle_to(float(i)-0.5,
##                     (y - width) + fnc(x1, y-width).imag,
##                     fnc(float(i)-0.5, y - width).real)
##         triangle_to(float(i),
##                     (y + width) + fnc(x1, y+width).imag,
##                     fnc(float(i), y + width).real)
##         triangle_to(float(i),
##                     (y - width) + fnc(x1, y-width).imag,
##                     fnc(float(i), y - width).real)
##     update()


# A feeble attempt at 4d
def str2(x1, x2, y=0, fnc=none, width=1, l = 1, focus_x=0, focus_y=0, focus_z = -34.64, w=1):
    v_x1 = float(x1 - focus_x)
    v_x2 = float(x1 - focus_x)
    v_y1 = float((y+width) - focus_y)
    v_y2 = float((y-width) - focus_y)
    v_z1 = float(-focus_z)
    v_z2 = float(-focus_z)
    len1 = fnc(x1, (y+width), 0) * w
    len2 = fnc(x1, (y-width), 0) * w #yes, x1 is right
    r1 = hypot3(v_x1, v_y1, v_z1)
    r2 = hypot3(v_x2, v_y2, v_z2)
    v_x1 = v_x1/r1; v_y1 = v_y1/r1; v_z1 = v_z1/r1;
    v_x2 = v_x2/r2; v_y2 = v_y2/r2; v_z2 = v_z2/r2;
    triangle_from(x1 + len1*v_x1, (y+width) + len1*v_y1,
                  x1 + len2*v_x2, (y-width) + len2*v_y2,
                  len1*v_z1, len2*v_z2,
                  l)
    for i in range(x1+1, x2+1):
        v_x1 = float(i - focus_x)
        v_x2 = float(i - focus_x)
        v_y1 = float((y+width) - focus_y)
        v_y2 = float((y-width) - focus_y)
        v_z1 = float(-focus_z)
        v_z2 = float(-focus_z)
        len1 = fnc(i, (y+width), 0) * w
        len2 = fnc(i, (y-width), 0) * w
        r1 = hypot3(v_x1, v_y1, v_z1)
        r2 = hypot3(v_x2, v_y2, v_z2)
        # sin normalizar el efecto es diferente
        v_x1 = v_x1/r1; v_y1 = v_y1/r1; v_z1 = v_z1/r1; 
        v_x2 = v_x2/r2; v_y2 = v_y2/r2; v_z2 = v_z2/r2;
        triangle_to(i + len1*v_x1, (y+width) + len1*v_y1, len1*v_z1)
        triangle_to(i + len2*v_x2, (y-width) + len2*v_y2, len2*v_z2)

### This is a mixing of the last two functions.
### fnc1 sets the z elevation , while fnc2 does the radial expansion.
### v is the height of the z elevation, and w is a factor for the
### vectors resultant of fnc2; both do the same job, v in parallel
### and w from the focus. Passing none and 1 to any of the functions
### reverts the behavior to one of the previous graphers.        
def str3(x1, x2, y=0, fnc=none, fnc2=none, width=1, l = 1, v = 1, w = 1, focus_x=0, focus_y=0, focus_z = 1.):#-34.64):
    v_x1 = float(x1 - focus_x)
    v_x2 = float(x1 - focus_x)
    v_y1 = float((y+width) - focus_y)
    v_y2 = float((y-width) - focus_y)
    v_z1 = float(fnc(x1, (y+width))*v-focus_z)
    v_z2 = float(fnc(x1, (y-width))*v-focus_z)
    len1 = fnc2(x1, (y+width), fnc(x1, (y+width))*v) * w
    len2 = fnc2(x1, (y-width), fnc(x1, (y-width))*v) * w #yes, x1 is right
    r1 = hypot3(v_x1, v_y1, v_z1)
    r2 = hypot3(v_x2, v_y2, v_z2)
    v_x1 = v_x1/r1; v_y1 = v_y1/r1; v_z1 = v_z1/r1;
    v_x2 = v_x2/r2; v_y2 = v_y2/r2; v_z2 = v_z2/r2;
    triangle_from(x1 + len1*v_x1, (y+width) + len1*v_y1,
                  x1 + len2*v_x2, (y-width) + len2*v_y2,
                  len1*v_z1 + fnc(x1, (y+width))*v,
                  len2*v_z2 + fnc(x1, (y-width))*v,
                  l)
    for i in range(x1+1, x2+1):
        v_x1 = float(i - focus_x)
        v_x2 = float(i - focus_x)
        v_y1 = float((y+width) - focus_y)
        v_y2 = float((y-width) - focus_y)
        v_z1 = float(fnc(i, (y+width))*v-focus_z)
        v_z2 = float(fnc(i, (y-width))*v-focus_z)
        len1 = fnc2(i, (y+width), fnc(i, (y+width))*v) * w
        len2 = fnc2(i, (y-width), fnc(i, (y-width))*v) * w
        r1 = hypot3(v_x1, v_y1, v_z1)
        r2 = hypot3(v_x2, v_y2, v_z2)
        v_x1 = v_x1/r1; v_y1 = v_y1/r1; v_z1 = v_z1/r1; 
        v_x2 = v_x2/r2; v_y2 = v_y2/r2; v_z2 = v_z2/r2;
        triangle_to(i + len1*v_x1, (y+width) + len1*v_y1, len1*v_z1 + fnc(i, (y+width))*v)
        triangle_to(i + len2*v_x2, (y-width) + len2*v_y2, len2*v_z2 + fnc(i, (y-width))*v)

# by using (x*2) instead of x I duplicated the vertical
# resolution of the volume mesh (modified for 'res')

# This is the equivalent of volume() using triangle strips
def vol2(x=20, y=20, fnc=none, l=1, d4=0, w=1, res = 2):
    for i in range(-(x*res), (x*res)+1):
        if not d4:
            str(-x, x, float(i)/res, fnc, 0.25, l)
        else:
            str2(-x, x, float(i)/res, fnc, 0.25, l, w=w)

## COMPLEX
## def cvol(fnc, x=20, y=20, l=1, d4=0, w=1, res = 2):
##     for i in range(-(x*res), (x*res)+1):
##         cstr(-x, x, float(i)/res, fnc, 0.25, l)

def mix( f1=none, f2=none, v = 1, w=1, l=1, x=20, y=20, res = 2):
    for i in range(-(x*res), (x*res)+1):
        str3(-x, x, float(i)/res, f1, f2, 0.25, l, v, w)        
        update()

def str_cut():
    for i in range(-20, 20):
        str(-20, 20, i, flat, 0.4, (i%4)+1)

